#include <MIDI.h>

MIDI_CREATE_DEFAULT_INSTANCE();

//these variables won't change
//#define LED 13
#define PAD1 A2
#define PAD2 A3
#define PAD3 A4
#define PAD4 A5
#define buttonDrum 5
#define buttonClear 6
#define buttonLoop 7
#define analogPotMap A1

int threshold = 300;
byte note1 = 28;
byte note2 = 29;
byte note3 = 30;
byte note4 = 31;
byte note5 = 32;
byte note6 = 33;
byte note7 = 34;
byte note8 = 35;
byte noteLoop = 50;
byte noteClear = 51;
byte MIDI_Volume = 7;

//These variables will change
int pad1hit = 0;
int pad2hit = 0;
int pad3hit = 0;
int pad4hit = 0;
int maximum4;
int DrumSet = 1;
int buttonDrumState = 1;
int lastButtonDrumState = 1;
int buttonPushCounter = 0;

byte tempAnalogPot;
byte analogPot;
byte analogDiff = 0;
int NOISE = 5;

int tempInputClear;
int inputClear;
int tempInputLoop;
int inputLoop;

void setup() {
  // put your setup code here, to run once:
  Serial.begin(115200);
  MIDI.begin(4);
  //pinMode(LED, OUTPUT);

  //Initialise anlogic Potentiometer 
  pinMode(analogPotMap, INPUT);
  analogPot = analogRead(analogPotMap) / 8;

  // Initialise buttons
  pinMode(buttonDrum, INPUT_PULLUP);
  
  pinMode(buttonClear, INPUT_PULLUP);
  inputClear = digitalRead(buttonClear);
  
  pinMode(buttonLoop, INPUT_PULLUP);
  inputLoop = digitalRead(buttonLoop);
}

void loop() {

  // The following line send MIDI message only if the analog value from the pot is more than NOISE (int NOISE defined above)to prevent noise
  // Inspiration of this code comes from Michael Balzer's Basic MIDI Controller code
  
  tempAnalogPot = analogRead(analogPotMap) / 8;

  analogDiff = abs(tempAnalogPot - analogPot);

  if (analogDiff >= NOISE)
  {
    // Record the new analogue value
    analogPot = tempAnalogPot;
    
    MIDI.sendControlChange(MIDI_Volume, analogPot, 1);
  }

  tempInputClear = digitalRead(buttonClear);

  if (inputClear != tempInputClear)
  {
    delay(2);               // wait 2 ms and take a 2nd reading for debounce
    if (tempInputClear == digitalRead(buttonClear))  // if 2nd reading is the same, assume it's true
    {
    // Record the new digital state
    inputClear = tempInputClear;

      if (inputClear == LOW) // Moved from HIGH to LOW
      {
        
        MIDI.sendNoteOn(noteClear, 127, 1);
        MIDI.sendNoteOff(noteClear, 0, 1);
      }
      /*else                  
      {
        MIDI.sendNoteOff(noteClear, 0, 1);
      }*/
    }
  }

  tempInputLoop = digitalRead(buttonLoop);

  if (inputLoop != tempInputLoop)
  {
    delay(2);               // wait 2 ms and take a 2nd reading for debounce
    if (tempInputLoop == digitalRead(buttonLoop))  // if 2nd reading is the same, assume it's true
    {
    // Record the new digital state
    inputLoop = tempInputLoop;

      if (inputLoop == LOW) // Moved from HIGH to LOW
      {
        
        MIDI.sendNoteOn(noteLoop, 127, 1);
        MIDI.sendNoteOff(noteLoop, 0, 1);
      }
     /* else                 
      {
        MIDI.sendNoteOff(noteLoop, 0, 1);
      }*/
    }
  }

  // the following lines change the value of DrumSet depending on the value of a counter changing with a press of one button. 2 different states for a single button pressed

     // read the pushbutton input pin:
  buttonDrumState = digitalRead(buttonDrum);

  // compare the buttonState to its previous state
  if (buttonDrumState != lastButtonDrumState) {
    // if the state has changed, increment the counter
    if (buttonDrumState == LOW) {
      // if the current state is LOW then the button went from off to on:
      buttonPushCounter++;
    //  Serial.print("number of button pushes: ");
    //  Serial.println(buttonPushCounter);
    } else {
      // if the current state is HIGH then the button went from on to off:
    }
    // compare the counter modulo 2. Each odd number will set drumset = 2 and even number will set drumset = 1
    if (buttonPushCounter % 2 == 0) {
    DrumSet = 1;
    //Serial.println("Drumset: 1 ");
    }
    else {
    DrumSet = 2;
    //Serial.println("Drumset: 2 ");
    }
  }
    delay(5);
  
  if (DrumSet == 1){                               // Send MIDI notes from drum set 1 by hitting piezo only if the signal is more than threshold
    
    if (analogRead(PAD1) >= threshold) {          
      pad1hit = 1;
      //Serial.print("max = ");
     //Serial.print(analogRead(PAD1));
    }
    if (pad1hit == 1 && analogRead(PAD1) <= (threshold - 100)){       
      int volume1 = analogRead(PAD1);
      //digitalWrite(LED, LOW);
      //Serial.print("Volume1 =");
     //Serial.print(analogRead(PAD1));
      MIDI.sendNoteOn(note1, volume1, 1);
      MIDI.sendNoteOff(note1, 0, 1);
      volume1=0;
      pad1hit = 0;
    }
    //digitalWrite(LED, LOW);
  
    
    if (analogRead(PAD2) >= threshold) {
      pad2hit = 1;
      //Serial.print("max = ");
     //Serial.print(analogRead(PAD1));
    }
    if (pad2hit == 1 && analogRead(PAD2) <= (threshold - 100)){
      int volume2 = analogRead(PAD2);
      //digitalWrite(LED, LOW);
      //Serial.print("Volume1 =");
     //Serial.print(analogRead(PAD1));
      MIDI.sendNoteOn(note2, volume2, 1);
      MIDI.sendNoteOff(note2, 0, 1);
      volume2=0;
      pad2hit = 0;
    }
    //digitalWrite(LED, LOW);
  
  
    if (analogRead(PAD3) >= threshold) {
      pad3hit = 1;
      //Serial.print("max = ");
     //Serial.print(analogRead(PAD1));
    }
    if (pad3hit == 1 && analogRead(PAD3) <= (threshold - 100)){
      int volume3 = analogRead(PAD3);
      //digitalWrite(LED, LOW);
      //Serial.print("Volume1 =");
     //Serial.print(analogRead(PAD1));
      MIDI.sendNoteOn(note3, volume3, 1);
      MIDI.sendNoteOff(note3, 0, 1);
      volume3=0;
      pad3hit = 0;
    }
    //digitalWrite(LED, LOW);
  
  
    if (analogRead(PAD4) >= threshold) {
      pad4hit = 1;
      maximum4 = analogRead(PAD4);
      Serial.print("max = ");
     Serial.print(maximum4);
    }
    if (pad4hit == 1 && analogRead(PAD4) <= (maximum4 - 100)){
      int volume4 = analogRead(PAD4);
      //digitalWrite(LED, LOW);
      Serial.print("Volume4 =");
     Serial.print(volume4);
      MIDI.sendNoteOn(note4, volume4, 1);
      MIDI.sendNoteOff(note4, 0, 1);
      volume4=0;
      pad4hit = 0;
    }
    //digitalWrite(LED, LOW);
  }

  if (DrumSet == 2){                                   // Send MIDI notes from drum set 2 by hitting piezo only if the signal is more than threshold    
    
    if (analogRead(PAD1) >= threshold) {
      pad1hit = 1;
      //Serial.print("max = ");
     //Serial.print(analogRead(PAD1));
    }
    if (pad1hit == 1 && analogRead(PAD1) <= (threshold - 100)){
      int volume5 = analogRead(PAD1);
      //digitalWrite(LED, LOW);
      //Serial.print("Volume1 =");
     //Serial.print(analogRead(PAD1));
      MIDI.sendNoteOn(note5, volume5, 1);
      MIDI.sendNoteOff(note5, 0, 1);
      volume5=0;
      pad1hit = 0;
    }
    //digitalWrite(LED, LOW);
  
    
    if (analogRead(PAD2) >= threshold) {
      pad2hit = 1;
      //Serial.print("max = ");
     //Serial.print(analogRead(PAD1));
    }
    if (pad2hit == 1 && analogRead(PAD2) <= (threshold - 100)){
      int volume6 = analogRead(PAD2);
      //digitalWrite(LED, LOW);
      //Serial.print("Volume1 =");
     //Serial.print(analogRead(PAD1));
      MIDI.sendNoteOn(note6, volume6, 1);
      MIDI.sendNoteOff(note6, 0, 1);
      volume6=0;
      pad2hit = 0;
    }
    //digitalWrite(LED, LOW);
  
  
    if (analogRead(PAD3) >= threshold) {
      pad3hit = 1;
      //Serial.print("max = ");
     //Serial.print(analogRead(PAD1));
    }
    if (pad3hit == 1 && analogRead(PAD3) <= (threshold - 100)){
      int volume7 = analogRead(PAD3);
      //digitalWrite(LED, LOW);
      //Serial.print("Volume1 =");
     //Serial.print(analogRead(PAD1));
      MIDI.sendNoteOn(note7, volume7, 1);
      MIDI.sendNoteOff(note7, 0, 1);
      volume7=0;
      pad3hit = 0;
    }
    //digitalWrite(LED, LOW);
  
  
    if (analogRead(PAD4) >= threshold) {
      pad4hit = 1;
      //Serial.print("max = ");
     //Serial.print(analogRead(PAD4));
    }
    if (pad4hit == 1 && analogRead(PAD4) <= (threshold - 100)){
      int volume8 = analogRead(PAD4);
      //digitalWrite(LED, LOW);
     // Serial.print("Volume8 =");
     //Serial.print(analogRead(PAD4));
     MIDI.sendNoteOn(note8, volume8, 1);
     MIDI.sendNoteOff(note8, 0, 1);
      volume8=0;
      pad4hit = 0;
    }
    //digitalWrite(LED, LOW);
  }
    // save the current state as the last state, for next time through the loop
  lastButtonDrumState = buttonDrumState;
}
