#include "DFRobot_ST7687S_Latch.h"

// this constant won't change:
const int  buttonPin = 8;
const int buttonLoop = 9;    // the pin that the pushbutton is attached to
const int ledPin = 13;       // the pin that the LED is attached to
#define analogPotMap A1

// Variables will change:
int buttonPushCounter = 0;
int newDrumState = 1;     // new state of the button
int oldDrumState = 1;     // previous state of the button

int buttonLoopCounter = 0;
int buttonLoopState = 1;
int lastButtonLoopState = 1;

int analogPot;
int tempAnalogPot;
int analogDiff;

#ifdef __AVR__
uint8_t pin_cs = 3, pin_rs = 5, pin_wr = 6, pin_lck = 7;
#else
uint8_t pin_cs = D3, pin_rs = D5, pin_wr = D6, pin_lck = D7;
#endif

DFRobot_ST7687S_Latch tft(pin_cs, pin_rs, pin_wr, pin_lck);

void setup() {
  // initialize the button pin as a input:
  pinMode(buttonPin, INPUT_PULLUP);
  // initialize the button loop as a input:
  pinMode(buttonLoop, INPUT_PULLUP);
  //Initialise anlogic Potentiometer 
  pinMode(analogPotMap, INPUT);
  analogPot = analogRead(analogPotMap) / 8;
  // initialize the LED as an output:
  pinMode(ledPin, OUTPUT);
  // initialize serial communication:
  Serial.begin(115200);
    // Initialyse display
  tft.begin();
  tft.fillScreen(DISPLAY_BLACK);

  
}


void loop() {
  // read the pushbutton input pin:
  newDrumState = digitalRead(buttonPin);

  if (newDrumState != oldDrumState){    // Toggle switch from drum sets 1 and 2
    
      if (newDrumState == LOW){     

       buttonPushCounter++;
      }

      delay(50);      
  }
  
   oldDrumState = newDrumState;


  // Display drumset 1 every 2 button pushes by checking the modulo of the
  // button push counter. the modulo function gives you the remainder of the
  // division of two numbers:
  if (buttonPushCounter % 2 == 0){

    tft.setCursor(25, 32);
    tft.setTextColor(DISPLAY_WHITE);  //set text color as white
    tft.setTextSize(2);  //2 * text size, default text size: 6 * 8
    tft.print("DrumSet");
    tft.setCursor(60, 54);
    tft.setTextColor(DISPLAY_RED);  //set text color as white
    tft.setTextSize(2);  //2 * text size, default text size: 6 * 8
    tft.print("1");
   }

  else {

    tft.setCursor(25, 32);
    tft.setTextColor(DISPLAY_WHITE);  //set text color as white
    tft.setTextSize(2);  //2 * text size, default text size: 6 * 8
    tft.print("DrumSet");
    tft.setCursor(60, 54);
    tft.setTextColor(DISPLAY_BLUE);  //set text color as white
    tft.setTextSize(2);  //2 * text size, default text size: 6 * 8
    tft.print("2");
  }

/* the following lines display the state of the loop depending on the value of a counter changing with a press of one button. 4 different states for a single button pressed

     // read the pushbutton input pin:
  buttonLoopState = digitalRead(buttonLoop);

  // compare the buttonState to its previous state
  if (buttonLoopState != lastButtonLoopState) {
    // if the state has changed, increment the counter
    if (buttonLoopState == LOW) {
      // if the current state is LOW then the button went from off to on:
      buttonLoopCounter++;
      Serial.print("number of button pushes: ");
      Serial.println(buttonLoopCounter);
    } else {
      // if the current state is HIGH then the button went from on to off:
    }
    // compare the counter modulo 4 to the values 1,2,3 and 0
    switch (buttonLoopCounter % 4) {
    case 0:
    tft.fillRect(-24, 11, 64, 40, DISPLAY_BLACK);  //fill rectangle
    tft.setCursor(40, 75);
    tft.setTextColor(DISPLAY_WHITE);  //set text color as white
    tft.setTextSize(1);  //2 * text size, default text size: 6 * 8
    tft.print("Stop");
    break;
    case 1:
    tft.fillRect(-24, 11, 64, 40, DISPLAY_BLACK);  //fill rectangle
    tft.setCursor(40, 75);
    tft.setTextColor(DISPLAY_RED);  //set text color as white
    tft.setTextSize(1);  //2 * text size, default text size: 6 * 8
    tft.print("Record");
    break;
    case 2:
    tft.fillRect(-24, 11, 64, 40, DISPLAY_BLACK);  //fill rectangle
    tft.setCursor(40, 75);
    tft.setTextColor(DISPLAY_RED);  //set text color as white
    tft.setTextSize(1);  //2 * text size, default text size: 6 * 8
    tft.print("Play");
    break;
    case 3:
    tft.fillRect(-24, 11, 64, 40, DISPLAY_BLACK);  //fill rectangle
    tft.setCursor(40, 75);
    tft.setTextColor(DISPLAY_ORANGE);  //set text color as white
    tft.setTextSize(1);  //2 * text size, default text size: 6 * 8
    tft.print("NoRecord");
    break;
  }
    delay(50);
  }
  // save the current state as the last state, for next time through the loop
  lastButtonLoopState = buttonLoopState;

// The following liens display the value of volume pot only if it changed more than 5

  tempAnalogPot = analogRead(analogPotMap) / 8;

  analogDiff = abs(tempAnalogPot - analogPot);

  if (analogDiff >= 5)
  {
    // Record the new analogue value
    analogPot = tempAnalogPot;
        
      if (analogPot <= 5){
        tft.setCursor(45, 110);
        tft.setTextColor(DISPLAY_WHITE);  //set text color as white
        tft.setTextSize(1);  //2 * text size, default text size: 6 * 8
        tft.print("Vol : 0");
        delay(100);    
      }
    
      else if(analogPot > 5 && analogPot <= 15){
        tft.setCursor(45, 110);
        tft.setTextColor(DISPLAY_WHITE);  //set text color as white
        tft.setTextSize(1);  //2 * text size, default text size: 6 * 8
        tft.print("Vol : 1");
        delay(100);
      }
    
      else if(analogPot > 15 && analogPot <= 31){
        tft.setCursor(45, 110);
        tft.setTextColor(DISPLAY_WHITE);  //set text color as white
        tft.setTextSize(1);  //2 * text size, default text size: 6 * 8
        tft.print("Vol : 2");
        delay(100);
      }
    
      else if(analogPot > 31 && analogPot <= 47){
        tft.setCursor(45, 110);
        tft.setTextColor(DISPLAY_WHITE);  //set text color as white
        tft.setTextSize(1);  //2 * text size, default text size: 6 * 8
        tft.print("Vol : 3");
        delay(100);
      }
    
        else if(analogPot > 47 && analogPot <= 63){
        tft.setCursor(45, 110);
        tft.setTextColor(DISPLAY_WHITE);  //set text color as white
        tft.setTextSize(1);  //2 * text size, default text size: 6 * 8
        tft.print("Vol : 4");
        delay(100);
      }
    
        else if(analogPot > 63 && analogPot <= 79){
        tft.setCursor(45, 110);
        tft.setTextColor(DISPLAY_WHITE);  //set text color as white
        tft.setTextSize(1);  //2 * text size, default text size: 6 * 8
        tft.print("Vol : 5");
        delay(100);
      }
    
        else if(analogPot > 79 && analogPot <= 95){
        tft.setCursor(45, 110);
        tft.setTextColor(DISPLAY_WHITE);  //set text color as white
        tft.setTextSize(1);  //2 * text size, default text size: 6 * 8
        tft.print("Vol : 6");
        delay(100);
      }
    
        else if(analogPot > 95 && analogPot <= 111){
        tft.setCursor(45, 110);
        tft.setTextColor(DISPLAY_WHITE);  //set text color as white
        tft.setTextSize(1);  //2 * text size, default text size: 6 * 8
        tft.print("Vol : 7");
        delay(100);
      }
    
        else if(analogPot > 111){
        tft.setCursor(45, 110);
        tft.setTextColor(DISPLAY_WHITE);  //set text color as white
        tft.setTextSize(1);  //2 * text size, default text size: 6 * 8
        tft.print("Vol : 8");
        delay(100);
      }
  }
*/
}
